
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ArtifactsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artifacts = await db.artifacts.create(
            {
                id: data.id || undefined,
        
        artifact_type: data.artifact_type
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        content_text: data.content_text
        ||
        null
            ,
            
        is_public: data.is_public
        ||
        false
        
            ,
            
        submitted_at: data.submitted_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await artifacts.setUser( data.user || null, {
            transaction,
        });
        
        await artifacts.setLesson( data.lesson || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.artifacts.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: artifacts.id,
            },
            data.attachments,
            options,
        );
        

        return artifacts;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const artifactsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                artifact_type: item.artifact_type
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                content_text: item.content_text
            ||
            null
            ,
            
                is_public: item.is_public
            ||
            false
        
            ,
            
                submitted_at: item.submitted_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const artifacts = await db.artifacts.bulkCreate(artifactsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < artifacts.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.artifacts.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: artifacts[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return artifacts;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const artifacts = await db.artifacts.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.artifact_type !== undefined) updatePayload.artifact_type = data.artifact_type;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.content_text !== undefined) updatePayload.content_text = data.content_text;
        
        
        if (data.is_public !== undefined) updatePayload.is_public = data.is_public;
        
        
        if (data.submitted_at !== undefined) updatePayload.submitted_at = data.submitted_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await artifacts.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await artifacts.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.lesson !== undefined) {
            await artifacts.setLesson(
              
              data.lesson,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.artifacts.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: artifacts.id,
            },
            data.attachments,
            options,
        );
        

        return artifacts;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artifacts = await db.artifacts.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of artifacts) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of artifacts) {
                await record.destroy({transaction});
            }
        });


        return artifacts;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const artifacts = await db.artifacts.findByPk(id, options);

        await artifacts.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await artifacts.destroy({
            transaction
        });

        return artifacts;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const artifacts = await db.artifacts.findOne(
            { where },
            { transaction },
        );

        if (!artifacts) {
            return artifacts;
        }

        const output = artifacts.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await artifacts.getUser({
            transaction
        });
        
        
        output.lesson = await artifacts.getLesson({
            transaction
        });
        
        
        output.attachments = await artifacts.getAttachments({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.lessons,
        as: 'lesson',
        
        where: filter.lesson ? {
          [Op.or]: [
            { id: { [Op.in]: filter.lesson.split('|').map(term => Utils.uuid(term)) } },
            {
              lesson_title: {
                [Op.or]: filter.lesson.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artifacts',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.content_text) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artifacts',
                        'content_text',
                        filter.content_text,
                    ),
                };
            }
            

            
            

            
            if (filter.submitted_atRange) {
                const [start, end] = filter.submitted_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    submitted_at: {
                    ...where.submitted_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.artifact_type) {
                where = {
                    ...where,
                artifact_type: filter.artifact_type,
            };
            }
            
            if (filter.is_public) {
                where = {
                    ...where,
                is_public: filter.is_public,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.artifacts.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'artifacts',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.artifacts.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

